package data.hullmods;

import java.util.HashMap;
import java.util.Map;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;

public class metelson_hullnode extends BaseHullMod {

	public static final float DAMAGE_REDUCTION = 15f;
	public static final float DAMAGE_PENALTY = 30f;
	
	private static Map mag = new HashMap();
	static {
		mag.put(HullSize.FRIGATE, 25f);
		mag.put(HullSize.DESTROYER, 75f);
		mag.put(HullSize.CRUISER, 125f);
		mag.put(HullSize.CAPITAL_SHIP, 200f);
	}
	
        @Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		
		stats.getArmorBonus().modifyFlat(id, (Float) mag.get(hullSize));
		
		stats.getProjectileDamageTakenMult().modifyMult(id, 1f - DAMAGE_REDUCTION * 0.01f);
		stats.getEmpDamageTakenMult().modifyMult(id, 1f - DAMAGE_REDUCTION * 0.01f);
		stats.getFragmentationDamageTakenMult().modifyMult(id, 1f - DAMAGE_REDUCTION * 0.01f);
		stats.getBeamDamageTakenMult().modifyMult(id, 1f + DAMAGE_PENALTY * 0.01f);
	}
	
        @Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + ((Float) mag.get(HullSize.FRIGATE)).intValue();
		if (index == 1) return "" + ((Float) mag.get(HullSize.DESTROYER)).intValue();
		if (index == 2) return "" + ((Float) mag.get(HullSize.CRUISER)).intValue();
		if (index == 3) return "" + ((Float) mag.get(HullSize.CAPITAL_SHIP)).intValue();
		if (index == 4) return "" + (int) DAMAGE_PENALTY;
		return null;
		//if (index == 0) return "" + ((Float) mag.get(hullSize)).intValue();
		//return null;
	}


}
